' Scott Adams adventure game interpreter.
' Written for Microsoft Qbasic by Chad Elliott 1999-2000.
' Based upon the findings of Alan Cox, Writer of
' the Scott-Free Interpreter.
' (Thanks man.)

' NOTE:    This program is freeware, and I have included the crappy source
'          code so that you make learn whatever you can figure out from it.
'          Please do not redistribute any modified versions of this file,
'          but please feel free to experiment with it, and most of all,
'          enjoy the great games of Scott Adams and Brian Howarth, as well as
'          all others written for the Scott Adams engine.

' NOTE2:   I hope to release a two word parser written with the same type
'          of style as scott's engine.  I am thinking of dropping in a small
'          graphic box in the corner, and allowing background music, as well
'          as having some nice fonts and maybe some sliding text backgrounds
'          such as parchment and note paper.  I don't work well with others
'          especially when it comes to programming (cause I am a jerk) but
'          as soon as I finalize the template for conditions / actions and
'          vocab strutures, and picture formats, I will release it on my
'          pathetic web page. (http://members.aol.com/icematrix)

' PS:      Thanks for all the games Scott, and when the heck are you
'          going to finish your new Return to Pirate Isle Game?  I want
'          to play it! :)
'
' KNOWN BUGS:
'              This interpreter won't play seas of blood worth diddly... so
'              I'll try to fix that later... however, I'm sure you'll have
'              plenty to do until then with the rest of the games made for
'              the adventure international interpreter.
'
'              Please send all good comments to: icematrix@aol.com
'----------------------------------------------------------------------------

'--- Yes, I do like to over-dimension everything... why not?  we do have
'    more than 16k of ram these days :)

DIM BITFLAGS(100)
DIM COUNTERS(100)
DIM ITEM$(200)          'DESCRIPTIONS OF ALL ITEMS
DIM ITEMS(200)          'INITIAL LOCATIONS OF ALL ITEMS
DIM ITEMLOCATIONS(200)  'CURRENT LOCATIONS OF ALL ITEMS
DIM AUTOGET$(200)       'SYNONYMS FOR THE ITEM NAMES
DIM MAP(100, 6)         'COMPASS DIRECTIONS FOR ALL ROOMS
DIM DESCRIPTION$(200)   'ROOM DESCRIPTIONS
DIM NOUN$(200)
DIM VERB$(200)
DIM SITUATIONS(500)     'NOUN-VERB COMBINATIONS THAT ARE THE BEGINNING OF
                        'EACH CONDITION / ACTION SET
DIM CONDITIONS(500, 5)
DIM ACTIONS(500, 2)
DIM MESSAGE$(200)
DIM PARAMETERS(10)
DIM SWAPROOMS(50)       'SOME ACTIONS REQUIRE SWAPPING OF CURRENT ROOM WITH
                        'A 'SAVED' VARIABLE

' ------------------------------------
'  RUN THE PRETTY ASCII INTROSCREEN
' ------------------------------------
COLOR 15, 0
CLS
GOSUB INTROMENU

' --------------------------------------------------
'  GAME LOAD CONSOLE (KIND OF FLIMSY... BUT
'  AT LEAST IT HANDLES REMOVE/ADD FILE EXTENSIONS
' --------------------------------------------------
CONSOLE:
CLS
COLOR 14, 0
PRINT
PRINT "PLEASE SELECT THE GAME YOU WISH TO PLAY"
PRINT "---------------------------------------"
COLOR 10, 0
FILES "*.DAT"
PRINT
COLOR 15, 0
DO
PRINT "PLEASE ENTER FILENAME: ";
LINE INPUT F$
LOOP WHILE LEN(F$) > 12 OR LEN(F$) < 1
IF LEN(F$) > 4 THEN
  IF UCASE$(RIGHT$(F$, 4)) = ".DAT" THEN F$ = MID$(F$, 1, LEN(F$) - 4)
END IF
F$ = F$ + ".DAT"
ADVFILE$ = UCASE$(F$)

' ---------------------------------------------
'  QBASIC HAS A TOUGH TIME WITH FILE
'  OPERATIONS, SO I WORTE THIS ROUTINE
'  TO MAKE A TEMPORARY FILE THAT HAS
'  ALL THE PROPER CARRIAGE RETURNS AND
'  LINE FEEDS... THIS *REALLY* MAKES LOADING
'  THE GAME FILES EASIER, AND IT MAKES
'  THIS INTERPRETER COMPATIBLE WITH
'  BRIAN HOWARTH'S GAMES.
' ---------------------------------------------
OPEN ADVFILE$ FOR INPUT AS #1
OPEN "ADVNTEMP.SAT" FOR OUTPUT AS #2
CLOSE #2
KILL "ADVNTEMP.SAT"
OPEN "ADVNTEMP.SAT" FOR OUTPUT AS #2
DO
  K$ = INPUT$(1, 1)
  IF ASC(K$) <> 13 THEN
    IF ASC(K$) = 10 THEN
      PRINT #2, TEMP$ + CHR$(13);
      TEMP$ = ""
    ELSE TEMP$ = TEMP$ + K$
    END IF
  END IF
LOOP WHILE NOT EOF(1)
CLOSE #1
CLOSE #2

' ------------------
'  OPEN GAME FILE
' ------------------
OPEN "ADVNTEMP.SAT" FOR INPUT AS #1

'--------------------------------------
'  LOAD THE HEADER IN (13 VARIABLES)
'--------------------------------------
INPUT #1, UNKNOWN
INPUT #1, NUMBEROFITEMS
INPUT #1, NUMBEROFACTIONS
INPUT #1, NUMBEROFWORDS
INPUT #1, NUMBEROFROOMS
INPUT #1, MAXWEIGHT
INPUT #1, STARTINGROOM
INPUT #1, TOTALTREASURES
INPUT #1, WORDLENGTH
INPUT #1, LIGHTLASTS
INPUT #1, NUMBEROFMESSAGES
INPUT #1, TREASUREROOM

'---------------------
'  LOAD THE ACTIONS
'---------------------
FOR X = 0 TO NUMBEROFACTIONS
  INPUT #1, SITUATIONS(X)
  INPUT #1, CONDITIONS(X, 0)
  INPUT #1, CONDITIONS(X, 1)
  INPUT #1, CONDITIONS(X, 2)
  INPUT #1, CONDITIONS(X, 3)
  INPUT #1, CONDITIONS(X, 4)
  INPUT #1, ACTIONS(X, 0)
  INPUT #1, ACTIONS(X, 1)
NEXT X

'-------------------------
'  LOAD NOUNS AND VERBS
'-------------------------
FOR X = 0 TO NUMBEROFWORDS
    INPUT #1, VERB$(X)
    INPUT #1, NOUN$(X)
NEXT X

'-------------------------------------
'  LOAD ROOM DESCRIPTIONS AND EXITS
'-------------------------------------
FOR X = 0 TO NUMBEROFROOMS
  INPUT #1, MAP(X, 0)
  INPUT #1, MAP(X, 1)
  INPUT #1, MAP(X, 2)
  INPUT #1, MAP(X, 3)
  INPUT #1, MAP(X, 4)
  INPUT #1, MAP(X, 5)
  INPUT #1, DESCRIPTION$(X)
NEXT X

'------------------
'  LOAD MESSAGES
'------------------
FOR X = 0 TO NUMBEROFMESSAGES
  INPUT #1, MESSAGE$(X)
NEXT X

'---------------------------------------
'  LOAD ITEMS AND LOCATIONS FOR ITEMS
'---------------------------------------
FOR X = 0 TO NUMBEROFITEMS
  INPUT #1, ITEM$(X)
  INPUT #1, ITEMS(X)
  ITEMLOCATIONS(X) = ITEMS(X)
NEXT X

'-----------------------------------
'  CLOSE AND DELETE THE TEMP FILE
'-----------------------------------
CLOSE #1
KILL "ADVNTEMP.SAT"

'---------------------------------------------------------------------------
'  THIS ROUTINE MAKES SURE THAT THE WORDLIST CONFORMS TO THE MAXIMUM WORD
'  LENGTH WHICH IS FOUND IN THE HEADER.
'---------------------------------------------------------------------------
FOR X = 0 TO NUMBEROFWORDS
  IF LEN(NOUN$(X)) > WORDLENGTH AND MID$(NOUN$(X), 1, 1) <> "*" THEN
    NOUN$(X) = MID$(NOUN$(X), 1, WORDLENGTH)
  END IF
  IF LEN(VERB$(X)) > WORDLENGTH AND MID$(VERB$(X), 1, 1) <> "*" THEN
    VERB$(X) = MID$(VERB$(X), 1, WORDLENGTH)
  END IF
NEXT X

'---------------------------------------------------------
'  SEPERATE THE ITEM DESCRIPTIONS AND THE ITEM SYNONYMS
'---------------------------------------------------------
FOR X = 0 TO NUMBEROFITEMS
  FOR Y = 1 TO LEN(ITEM$(X))
    IF MID$(ITEM$(X), Y, 1) = "/" THEN
      AUTOGET$(X) = UCASE$(MID$(ITEM$(X), Y + 1, LEN(ITEM$(X)) - Y - 1))
      ITEM$(X) = LEFT$(ITEM$(X), Y - 1)
    END IF
  NEXT Y
NEXT X

'----------------------------------------------------------------------------
'  MISCELANEOUS PRE-GAME CODE
'----------------------------------------------------------------------------
CURRENTROOM = STARTINGROOM
ID = UNKNOWN + NUMBEROFITEMS + NUMBEROFACTIONS + NUMBEROFACTIONS + NUMBEROFWORDS
CURRENTCOUNTER = 90
GOSUB CALCULATESCORE
LAMP = LIGHTLASTS

OPEN "CARDS.SAT" FOR INPUT AS #1
INPUT #1, CN
CLOSE #1

FCTOP = 15
BCTOP = 2
FCBOT = 15
BCBOT = 2

COLOR FCBOT, BCBOT
CLS
GOSUB DRAWROOM
GOSUB AUTOACT

'----------------------------------------------------------------------------
'                   TEXT PARSER ۲
'----------------------------------------------------------------------------
DO
  W1$ = ""
  W2$ = ""
  NOUNFOUND = 0
  VERBFOUND = 0
  NOUN = 0
  VERB = 0
  ACTIONSDONE = 0
  GAMESAVED = 0
  GAMELOADED = 0

' -----------------------------------------------------
'  I DECIDED TO SCRAP THE IDEA OF HAVING A REDRAW
'  VARIABLE SYSTEM, IT CAUSES WAY TOO MANY PROBLEMS.
'  SINCE THIS IS A SPLIT WINDOW INTERPRETER, A REDRAW
'  EACH TIME A COMMAND IS TYPED ISN'T A BAD IDEA, AND
'  IF YOU LIKE TO PLAY SCOTT ADAMS EARLY STUFF, THEN YOU
'  PROBABLY ACTUALLY ENJOY WAITING A HALF A SEC AFTER EACH
'  COMMAND...
' ------------------------------------------------------
 
  INPUT ">", K$
  K$ = UCASE$(K$)

  IF K$ = "SAVEGAME" THEN
    IF OPT <> 4 THEN OPT = 0
    GOSUB CARDSUP
    GOSUB DRAWROOM
    IF GAMESAVED = 1 THEN PRINT "Game saved to card "; CN
    IF GAMELOADED = 1 THEN PRINT "Game loaded from card "; CN
    K$ = ""
  END IF

  IF K$ = "LOADGAME" THEN
    OPT = 1
    GOSUB CARDSUP
    GOSUB DRAWROOM
    IF GAMESAVED = 1 THEN PRINT "Game saved to card "; CN
    IF GAMELOADED = 1 THEN PRINT "Game loaded from card "; CN
    K$ = ""
  END IF

  IF LEN(K$) > 0 THEN
 
    FOR X = 0 TO LEN(K$)
     IF MID$(K$, X + 1, 1) = " " OR X = LEN(K$) THEN
      W1$ = MID$(K$, 1, X)
      IF X + 2 < LEN(K$) THEN
        W2$ = MID$(K$, X + 2, LEN(K$) - X + 2)
        FULLVERB$ = W1$
        FULLNOUN$ = W2$
        EXIT FOR
        END IF
      END IF
    NEXT X

    IF LEN(W1$) > WORDLENGTH THEN W1$ = MID$(W1$, 1, WORDLENGTH)
    IF LEN(W2$) > WORDLENGTH THEN W2$ = MID$(W2$, 1, WORDLENGTH)

    FOR X = 0 TO NUMBEROFWORDS
      IF MID$(VERB$(X), 1, 1) <> "*" THEN VERB = X
      IF VERB$(X) = W1$ THEN VERBFOUND = 1
      IF MID$(VERB$(X), 1, 1) = "*" THEN
        IF W1$ = MID$(VERB$(X), 2, LEN(VERB$(X)) - 1) THEN VERBFOUND = 1
      END IF
    IF VERBFOUND = 1 THEN EXIT FOR
    NEXT X

    IF W2$ <> "" THEN
      FOR X = 0 TO NUMBEROFWORDS
        IF MID$(NOUN$(X), 1, 1) <> "*" THEN NOUN = X
        IF NOUN$(X) = W2$ THEN NOUNFOUND = 1
        IF MID$(NOUN$(X), 1, 1) = "*" THEN
          IF W2$ = MID$(NOUN$(X), 2, LEN(NOUN$(X)) - 1) THEN NOUNFOUND = 1
        END IF
      IF NOUNFOUND = 1 THEN EXIT FOR
      NEXT X
    END IF
 
    '---------------------------
    ' SMART DIRECTION PARSING
    '---------------------------
    IF W1$ = "N" OR W1$ = "NOR" THEN
      IF W2$ = "" THEN
        VERB = 1
        NOUN = 1
      END IF
    END IF
 
    IF W1$ = "S" OR W1$ = "SOU" THEN
      IF W2$ = "" THEN
        VERB = 1
        NOUN = 2
      END IF
    END IF

    IF W1$ = "E" OR W1$ = "EAS" THEN
      IF W2$ = "" THEN
        VERB = 1
        NOUN = 3
      END IF
    END IF

    IF W1$ = "W" OR W1$ = "WES" THEN
      IF W2$ = "" THEN
        VERB = 1
        NOUN = 4
      END IF
    END IF
 
    IF W1$ = "U" OR W1$ = "UP" THEN
      IF W2$ = "" THEN
        VERB = 1
        NOUN = 5
      END IF
    END IF

    IF W1$ = "D" OR W1$ = "DOW" THEN
      IF W2$ = "" THEN
        VERB = 1
        NOUN = 6
      END IF
    END IF
   
    IF BITFLAGS(15) = 1 THEN
      IF ITEMLOCATIONS(9) <> CURRENTROOM AND ITEMLOCATIONS(9) <> -1 THEN
        IF VERB = 1 AND NOUN > 0 AND NOUN < 7 THEN
          IF DWALK > 0 THEN
            PRINT "Unable to see where you are going, you slip on something."
            PRINT "Being the lucky person you are you fall and break your neck."
            PRINT
            PRINT "Game over."
            COLOR 15, 0
            END
              ELSE
              DWALK = 1
              PRINT "It's dangerous to walk in the dark..."
              PRINT "o.k."
          END IF
        END IF
      END IF
    END IF

    IF VERBFOUND = 1 AND NOUNFOUND = 0 OR VERBFOUND = 1 AND NOUNFOUND = 1 THEN
        GOSUB ACTIONENGINE
        IF ACTIONSDONE = 0 AND CONDITIONSCHECKED = 1 THEN
          IF VERB <> 10 AND VERB <> 18 THEN PRINT "I can't do that yet..."
        END IF
        IF ACTIONSDONE = 0 AND CONDITIONSCHECKED = 0 THEN
          IF VERB <> 10 AND VERB <> 18 THEN PRINT "Sorry, I don't understand your command."
        END IF
        ELSE
        IF VERBFOUND = 0 AND NOUNFOUND = 0 AND VERB <> 1 THEN PRINT "Sorry, I don't understand..."
        IF VERBFOUND = 0 AND NOUNFOUND = 1 AND LEN(W1$) > 0 AND NOUN > 6 THEN PRINT "Sorry, I don't know the word '"; FULLVERB$; "'"
    END IF

    IF VERB = 1 THEN
      IF NOUN > 0 AND NOUN < 7 THEN
        SWAPROOM = 1000
        IF NOUN = 1 AND MAP(CURRENTROOM, 0) > 0 THEN SWAPROOM = MAP(CURRENTROOM, 0)
        IF NOUN = 2 AND MAP(CURRENTROOM, 1) > 0 THEN SWAPROOM = MAP(CURRENTROOM, 1)
        IF NOUN = 3 AND MAP(CURRENTROOM, 2) > 0 THEN SWAPROOM = MAP(CURRENTROOM, 2)
        IF NOUN = 4 AND MAP(CURRENTROOM, 3) > 0 THEN SWAPROOM = MAP(CURRENTROOM, 3)
        IF NOUN = 5 AND MAP(CURRENTROOM, 4) > 0 THEN SWAPROOM = MAP(CURRENTROOM, 4)
        IF NOUN = 6 AND MAP(CURRENTROOM, 5) > 0 THEN SWAPROOM = MAP(CURRENTROOM, 5)
        IF SWAPROOM <> 1000 THEN
          CURRENTROOM = SWAPROOM
          ACTIONSDONE = 1
          VERBFOUND = 0
          NOUNFOUND = 0
          PRINT "o.k."
          ELSE PRINT "Sorry, I can't go that way..."
        END IF
      END IF
    END IF
   
    IF VERB = 10 AND ACTIONSDONE = 0 THEN GOSUB TAKESUB
    IF VERB = 18 AND ACTIONSDONE = 0 THEN GOSUB DROPSUB

    IF ACTIONSDONE = 1 THEN GOSUB AUTOACT

  END IF

LOOP
COLOR 15, 0
END
'----------------------------------------------------------------------------

' -------------------------------
'  ROOM DRAWING SUBROUTINE 
' -------------------------------
DRAWROOM:

IF BITFLAGS(15) = 0 OR ITEMLOCATIONS(9) = CURRENTROOM OR ITEMLOCATIONS(9) = -1 THEN
  DWALK = 0
END IF

VIEW PRINT 1 TO 13
IF BITFLAGS(15) = 0 THEN COLOR FCTOP, BCTOP
IF BITFLAGS(15) = 1 AND ITEMLOCATIONS(9) <> CURRENTROOM AND ITEMLOCATIONS(9) <> -1 THEN COLOR 15, 1
IF BITFLAGS(15) = 1 AND ITEMLOCATIONS(9) = CURRENTROOM OR BITFLAGS(15) = 1 AND ITEMLOCATIONS(9) = -1 THEN COLOR 15, 6

FOR X = 0 TO 10
  PRINT "                                                                                "
NEXT X
LOCATE 1

IF BITFLAGS(15) = 0 OR ITEMLOCATIONS(9) = CURRENTROOM OR ITEMLOCATIONS(9) = -1 THEN
  TEMP$ = UCASE$(MID$(DESCRIPTION$(CURRENTROOM), 1, 1))
  IF TEMP$ <> "*" THEN
    PRINT "I'm in a ";
    PRINT DESCRIPTION$(CURRENTROOM)
    ELSE PRINT MID$(DESCRIPTION$(CURRENTROOM), 2, LEN(DESCRIPTION$(CURRENTROOM)) - 1)
  END IF
ELSE PRINT "It's too dark to see."
END IF

PRINT
PRINT "OBVIOUS EXITS: ";
 
IF BITFLAGS(15) = 0 OR ITEMLOCATIONS(9) = CURRENTROOM OR ITEMLOCATIONS(9) = -1 THEN
  IF MAP(CURRENTROOM, 0) <> 0 THEN PRINT "NORTH ";
  IF MAP(CURRENTROOM, 1) <> 0 THEN PRINT "SOUTH ";
  IF MAP(CURRENTROOM, 2) <> 0 THEN PRINT "EAST ";
  IF MAP(CURRENTROOM, 3) <> 0 THEN PRINT "WEST ";
  IF MAP(CURRENTROOM, 4) <> 0 THEN PRINT "UP ";
  IF MAP(CURRENTROOM, 5) <> 0 THEN PRINT "DOWN";
END IF

PRINT
PRINT
PRINT "VISIBLE ITEMS: ";

IF BITFLAGS(15) = 0 OR ITEMLOCATIONS(9) = CURRENTROOM OR ITEMLOCATIONS(9) = -1 THEN
  FOR X = 0 TO NUMBEROFWORDS
    IF ITEMLOCATIONS(X) = CURRENTROOM THEN
      TEMP$ = ITEM$(X) + " - "
      IF POS(0) + LEN(TEMP$) > 80 THEN PRINT
      PRINT TEMP$;
    END IF
  NEXT X
  IF CSRLIN > 0 AND POS(0) - 2 > 0 THEN
    LOCATE CSRLIN, POS(0) - 2
    PRINT "."
  END IF
END IF

LOCATE 10
PRINT "<------------------------------------------------------------------------------>";
VIEW PRINT 11 TO 25
COLOR FCBOT, BCBOT
LOCATE 25
PRINT "                                                                                "
RETURN

' ---------------------------------------------------------------------------
'  CONDITION-ACTION ENGINE 
' ---------------------------------------------------------------------------
ACTIONENGINE:

CURRENTSITUATION = -1
CONDITIONSCHECKED = 0

DO
  CURRENTSITUATION = CURRENTSITUATION + 1

  ' ----------------------------------------
  '  PERFORM NORMAL (NOUN) (VERB) ACTIONS
  ' ----------------------------------------
  IF SITUATIONS(CURRENTSITUATION) \ 150 = VERB THEN
    IF SITUATIONS(CURRENTSITUATION) MOD 150 = NOUN THEN
    CONDITIONSCHECKED = 1
    GOSUB CHECKCONDITIONS
    END IF
  END IF

LOOP WHILE CURRENTSITUATION < NUMBEROFACTIONS AND ACTIONSDONE = 0

  ' -------------------------------
  '  PERFORM (VERB) ANY ACTIONS
  ' -------------------------------
IF ACTIONSDONE = 0 THEN
  CURRENTSITUATION = -1
  DO
    CURRENTSITUATION = CURRENTSITUATION + 1
    IF SITUATIONS(CURRENTSITUATION) \ 150 = VERB THEN
      IF SITUATIONS(CURRENTSITUATION) MOD 150 = 0 THEN
        GOSUB CHECKCONDITIONS
      END IF
    END IF
  LOOP WHILE CURRENTSITUATION < NUMBEROFACTIONS AND ACTIONSDONE = 0
END IF
RETURN

' -------------------------------------
'  CONDITION ENGINE
' -------------------------------------
CHECKCONDITIONS:

CONTINUATION = 0
DO
 
  FOR X = 0 TO 9
    PARAMETERS(X) = 0
  NEXT X

  ALLCONDITIONSMET = 1
  CURRENTPARAMETER = 0

  FOR X = 0 TO 4

    C = (CONDITIONS(CURRENTSITUATION, X) MOD 20)
    P = (CONDITIONS(CURRENTSITUATION, X) \ 20)

        IF C = 0 THEN
          PARAMETERS(CURRENTPARAMETER) = P
          CURRENTPARAMETER = CURRENTPARAMETER + 1
        END IF

        IF C = 1 THEN
          IF ITEMLOCATIONS(P) <> -1 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 2 THEN
          IF ITEMLOCATIONS(P) <> CURRENTROOM THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 3 THEN
          IF ITEMLOCATIONS(P) <> CURRENTROOM AND ITEMLOCATIONS(P) <> -1 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 4 THEN
          IF CURRENTROOM <> P THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 5 THEN
          IF ITEMLOCATIONS(P) = CURRENTROOM THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 6 THEN
          IF ITEMLOCATIONS(P) = -1 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 7 THEN
          IF CURRENTROOM = P THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 8 THEN
          IF BITFLAGS(P) = 0 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 9 THEN
          IF BITFLAGS(P) = 1 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 10 THEN
          IF INVENTORYWEIGHT = 0 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 11 THEN
          IF INVENTORYWEIGHT <> 0 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 12 THEN
          IF ITEMLOCATIONS(P) = -1 OR ITEMLOCATIONS(P) = CURRENTROOM THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 13 THEN
          IF ITEMLOCATIONS(P) = 0 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 14 THEN
          IF ITEMLOCATIONS(P) <> 0 THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 15 THEN
          IF COUNTERS(CURRENTCOUNTER) > P THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 16 THEN
          IF COUNTERS(CURRENTCOUNTER) <= P THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 17 THEN
          IF ITEMLOCATIONS(P) <> ITEMS(P) THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 18 THEN
          IF ITEMLOCATIONS(P) = ITEMS(P) THEN ALLCONDITIONSMET = 0
        END IF

        IF C = 19 THEN
          IF COUNTERS(CURRENTCOUNTER) <> P THEN ALLCONDITIONSMET = 0
        END IF
 
  NEXT X
 
  IF ALLCONDITIONSMET = 1 THEN
    GOSUB DOACTIONS
    ACTIONSDONE = 1
  END IF
 
    IF CONTINUATION > 0 THEN
      IF SITUATIONS(CURRENTSITUATION + 1) \ 150 = 0 THEN
        IF SITUATIONS(CURRENTSITUATION + 1) MOD 150 = 0 THEN
        CONTINUATION = 2
        CURRENTSITUATION = CURRENTSITUATION + 1
        ELSE CONTINUATION = 0
        END IF
      ELSE CONTINUATION = 0
      END IF
    END IF

LOOP WHILE CONTINUATION > 1

RETURN

' ----------------------------------------
'  ACTION ENGINE
' ----------------------------------------
DOACTIONS:
CP = 0

FOR ACTIONCOUNT = 0 TO 3

DIM A(5)

A(0) = ACTIONS(CURRENTSITUATION, 0) \ 150
A(1) = ACTIONS(CURRENTSITUATION, 0) MOD 150
A(2) = ACTIONS(CURRENTSITUATION, 1) \ 150
A(3) = ACTIONS(CURRENTSITUATION, 1) MOD 150


        IF A(ACTIONCOUNT) > 0 AND A(ACTIONCOUNT) < 52 THEN
        PRINT MESSAGE$(A(ACTIONCOUNT))
        END IF

        IF A(ACTIONCOUNT) > 101 THEN
        PRINT MESSAGE$(A(ACTIONCOUNT) - 50)
        END IF

        IF A(ACTIONCOUNT) = 52 THEN
          IF INVENTORYWEIGHT < MAXWEIGHT THEN
            ITEMLOCATIONS(PARAMETERS(CP)) = -1
            INVENTORYWEIGHT = INVENTORYWEIGHT + 1
            GOSUB CALCULATESCORE
            CP = CP + 1
            ELSE PRINT "I'm already carrying too much."
          END IF
        END IF

        IF A(ACTIONCOUNT) = 53 THEN
          ITEMLOCATIONS(PARAMETERS(CP)) = CURRENTROOM
          GOSUB CALCULATESCORE
          CP = CP + 1
          
        END IF

        IF A(ACTIONCOUNT) = 54 THEN
          CURRENTROOM = PARAMETERS(CP)
          CP = CP + 1
          
        END IF

        IF A(ACTIONCOUNT) = 55 OR A(ACTIONCOUNT) = 59 THEN
          ITEMLOCATIONS(PARAMETERS(CP)) = 0
          GOSUB CALCULATESCORE
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 56 THEN
          BITFLAGS(15) = 1
        END IF

        IF A(ACTIONCOUNT) = 57 THEN
          BITFLAGS(15) = 0
        END IF

        IF A(ACTIONCOUNT) = 58 THEN
          BITFLAGS(PARAMETERS(CP)) = 1
          CP = CP + 1
        END IF

        '  59 SAME AS 55 FOR NOW

        IF A(ACTIONCOUNT) = 60 THEN
          BITFLAGS(PARAMETERS(CP)) = 0
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 61 THEN
          BITFLAGS(15) = 0
          CURRENTROOM = NUMBEROFROOMS
          GOSUB AUTOACT
        END IF

        IF A(ACTIONCOUNT) = 62 THEN
          ITEMLOCATIONS(PARAMETERS(CP)) = PARAMETERS(CP + 1)
          GOSUB CALCULATESCORE
          CP = CP + 2
        END IF

        IF A(ACTIONCOUNT) = 63 THEN
          PRINT "GAME OVER"
          COLOR 15, 0
          END
        END IF

        IF A(ACTIONCOUNT) = 64 OR A(ACTIONCOUNT) = 76 THEN
        GOSUB DRAWROOM
        END IF

        IF A(ACTIONCOUNT) = 65 THEN
          IF SCORE = TOTALTREASURES THEN
            VIEW PRINT 1 TO 25
            COLOR 14, 9
            CLS
            PRINT "Your score is:"; (SCORE * 100) \ TOTALTREASURES; "%"
            PRINT "You have collected and stored"; SCORE; "treasures."
            PRINT "Congratulations, you are truly a great adventurer!"
            PRINT
            PRINT "Game over."
            END
          END IF
          IF SCORE > 0 THEN
          PRINT "Your score is:"; (SCORE * 100) \ TOTALTREASURES; "%"
          PRINT "You have collected and stored"; SCORE; "treasures."
          ELSE
          PRINT "Your score is: 0%"
          PRINT "You have collected and stored 0 treasures."
          END IF
        END IF

        IF A(ACTIONCOUNT) = 66 THEN
          GOSUB INVENTORY
        END IF

        IF A(ACTIONCOUNT) = 67 THEN
          BITFLAGS(0) = 1
        END IF

        IF A(ACTIONCOUNT) = 68 THEN
          BITFLAGS(0) = 0
        END IF

        IF A(ACTIONCOUNT) = 69 THEN
          LAMP = LIGHTLASTS
        END IF

        IF A(ACTIONCOUNT) = 70 THEN
        END IF

        IF A(ACTIONCOUNT) = 71 THEN
          ' SAVE GAME
          IF OPT <> 4 THEN OPT = 0
          GOSUB CARDSUP
          GOSUB DRAWROOM
          IF GAMESAVED = 1 THEN PRINT "Game saved to card "; CN
          IF GAMELOADED = 1 THEN PRINT "Game loaded from card "; CN
        END IF

        IF A(ACTIONCOUNT) = 72 THEN
          SWAPVALUE = ITEMLOCATIONS(PARAMETERS(CP))
          ITEMLOCATIONS(PARAMETERS(CP)) = ITEMLOCATIONS(PARAMETERS(CP + 1))
          ITEMLOCATIONS(PARAMETERS(CP + 1)) = SWAPVALUE
          GOSUB CALCULATESCORE
          CP = CP + 2
        END IF

        IF A(ACTIONCOUNT) = 73 THEN
          CONTINUATION = 1
        END IF

        IF A(ACTIONCOUNT) = 74 THEN
          ITEMLOCATIONS(PARAMETERS(CP)) = -1
          GOSUB CALCULATESCORE
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 75 THEN
          ITEMLOCATIONS(PARAMETERS(CP)) = ITEMLOCATIONS(PARAMETERS(CP + 1))
          GOSUB CALCULATESCORE
          CP = CP + 2
        END IF

        '  76 SAME AS 64

        IF A(ACTIONCOUNT) = 77 THEN
          IF COUNTERS(CURRENTCOUNTER) >= 0 THEN
            COUNTERS(CURRENTCOUNTER) = COUNTERS(CURRENTCOUNTER) - 1
          END IF
        END IF

        IF A(ACTIONCOUNT) = 78 THEN
          PRINT COUNTERS(CURRENTCOUNTER);
        END IF

        IF A(ACTIONCOUNT) = 79 THEN
          COUNTERS(CURRENTCOUNTER) = PARAMETERS(CP)
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 80 THEN
          SWAPVALUE = CURRENTROOM
          CURRENTROOM = SWAPROOMS(35)
          SWAPROOMS(35) = SWAPVALUE
        END IF

        IF A(ACTIONCOUNT) = 81 THEN
          SWAPVALUE = COUNTERS(CURRENTCOUNTER)
          COUNTERS(CURRENTCOUNTER) = COUNTERS(PARAMETERS(CP))
          COUNTERS(PARAMETERS(CP)) = SWAPVALUE
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 82 THEN
          COUNTERS(CURRENTCOUNTER) = COUNTERS(CURRENTCOUNTER) + PARAMETERS(CP)
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 83 THEN
          COUNTERS(CURRENTCOUNTER) = COUNTERS(CURRENTCOUNTER) - PARAMETERS(CP)
          IF COUNTERS(CURRENTCOUNTER) < -1 THEN COUNTERS(CURRENTCOUNTER) = -1
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 84 THEN
          PRINT UCASE$(FULLNOUN$);
        END IF

        IF A(ACTIONCOUNT) = 85 THEN
          PRINT UCASE$(FULLNOUN$)
        END IF

        IF A(ACTIONCOUNT) = 86 THEN
          PRINT
        END IF

        IF A(ACTIONCOUNT) = 87 THEN
          SWAPVALUE = CURRENTROOM
          CURRENTROOM = SWAPROOMS(PARAMETERS(CP))
          SWAPROOMS(PARAMETERS(CP)) = SWAPVALUE
          CP = CP + 1
        END IF

        IF A(ACTIONCOUNT) = 88 THEN
          SLEEP 1
        END IF

        IF A(ACTIONCOUNT) = 89 THEN ' DRAWS PICTURES IN SAGA GAMES... NO SUPPORT YET
          CP = CP + 1
        END IF

NEXT ACTIONCOUNT

RETURN

' ----------------------------------------
'  INVENTORY ROUTINE
' ----------------------------------------
INVENTORY:
PRINT "You are carrying: ";
ITEMCOUNTER = 0
FOR X = 0 TO NUMBEROFITEMS
  IF ITEMLOCATIONS(X) = -1 THEN
    IF POS(0) + LEN(ITEM$(X)) > 80 THEN PRINT
    PRINT ITEM$(X); " - ";
    ITEMCOUNTER = ITEMCOUNTER + 1
  END IF
NEXT X
IF ITEMCOUNTER = 0 THEN PRINT "Nothing at all..."
IF POS(0) > 2 THEN
  LOCATE CSRLIN, POS(0) - 2
  PRINT "."
END IF
PRINT
RETURN

' ----------------------------------------
'  TAKE ITEM SUBROUTINE
' ----------------------------------------
TAKESUB:
ITEMTAKEN = 0
TEMPWORD$ = ""

  FOR B = 0 TO NUMBEROFITEMS
    IF ITEMLOCATIONS(B) = CURRENTROOM THEN
      FOR Y = 1 TO LEN(ITEM$(B))
        IF MID$(ITEM$(B), Y, 1) <> " " THEN TEMPWORD$ = TEMPWORD$ + UCASE$(MID$(ITEM$(B), Y, 1))
        IF MID$(ITEM$(B), Y, 1) = " " OR Y = LEN(ITEM$(B)) THEN
          IF LEN(TEMPWORD$) > WORDLENGTH THEN TEMPWORD$ = LEFT$(TEMPWORD$, WORDLENGTH)
          IF TEMPWORD$ = W2$ AND LEN(AUTOGET$(B)) > 0 OR W2$ = AUTOGET$(B) THEN
            W2$ = AUTOGET$(B)
            IF ITEMLOCATIONS(B) = CURRENTROOM THEN
              IF INVENTORYWEIGHT < MAXWEIGHT THEN
                ITEMLOCATIONS(B) = -1
                PRINT "o.k."
                GOSUB CALCULATESCORE
                ACTIONSDONE = 1
                INVENTORYWEIGHT = INVENTORYWEIGHT + 1
                ITEMTAKEN = 1
                EXIT FOR
              END IF
              IF INVENTORYWEIGHT = MAXWEIGHT THEN
                ITEMTAKEN = 2
                EXIT FOR
              END IF
            END IF
          END IF
        IF TEMPWORD$ = W2$ AND LEN(AUTOGET$(B)) = 0 THEN ITEMTAKEN = 3
        TEMPWORD$ = ""
        END IF
      NEXT Y
    END IF
  IF ITEMTAKEN = 1 THEN EXIT FOR
  IF ITEMTAKEN = 2 THEN EXIT FOR
  NEXT B

IF ITEMTAKEN = 3 THEN PRINT "It is beyond my power to do that."
IF ITEMTAKEN = 2 THEN PRINT "I am already carrying too much."
IF ITEMTAKEN = 0 THEN PRINT "I don't see that here."
RETURN

' ----------------------------------------
'  DROP ITEM ROUTINE
' ----------------------------------------
DROPSUB:
CARRIED = 0
TEMPWORD$ = ""

FOR B = 0 TO NUMBEROFITEMS
  IF ITEMLOCATIONS(B) = -1 THEN
    FOR A = 1 TO LEN(ITEM$(B))
      IF MID$(ITEM$(B), A, 1) <> " " THEN TEMPWORD$ = TEMPWORD$ + UCASE$(MID$(ITEM$(B), A, 1))
      IF MID$(ITEM$(B), A, 1) = " " OR A = LEN(ITEM$(B)) THEN
        IF LEN(TEMPWORD$) > WORDLENGTH THEN TEMPWORD$ = LEFT$(TEMPWORD$, WORDLENGTH)
        IF TEMPWORD$ = W2$ AND LEN(AUTOGET$(B)) > 0 OR W2$ = AUTOGET$(B) THEN
          W2$ = AUTOGET$(B)
          ITEMLOCATIONS(B) = CURRENTROOM
          PRINT "o.k."
          GOSUB CALCULATESCORE
          ACTIONSDONE = 1
          INVENTORYWEIGHT = INVENTORYWEIGHT - 1
          CARRIED = 1
          EXIT FOR
        END IF
      IF TEMPWORD$ = W2$ AND LEN(AUTOGET$(B)) = 0 THEN
        PRINT "It is beyond my power to do that."
        CARRIED = 1
      END IF
      TEMPWORD$ = ""
      END IF
    NEXT A
  END IF
  IF CARRIED = 1 THEN EXIT FOR
NEXT B
IF CARRIED = 0 THEN
  PRINT "I am not carrying that."
END IF
RETURN

' ------------------------
'  PERFORM AUTO ACTIONS
' ------------------------
AUTOACT:
FOR Y = 0 TO NUMBEROFACTIONS
  CURRENTSITUATION = Y
  IF SITUATIONS(Y) \ 150 = 0 THEN
    RANDOMIZE TIMER
    RVAL = INT(RND(1) * 100)
    IF SITUATIONS(Y) MOD 150 > RVAL THEN
      GOSUB CHECKCONDITIONS
    END IF
  END IF
NEXT Y

IF LAMP = 1 THEN BITFLAGS(16) = 1
IF LAMP > 0 AND LAMP < 25 THEN
  IF ITEMLOCATIONS(9) = CURRENTROOM OR ITEMLOCATIONS(9) = -1 THEN PRINT "Your light is flickering..."; LAMP; " more moves until it goes out."
END IF
IF ITEMLOCATIONS(9) = -1 OR ITEMLOCATIONS(9) = CURRENTROOM THEN LAMP = LAMP - 1
IF LAMP < 0 THEN LAMP = 0
GOSUB DRAWROOM
RETURN

' --------------------
'  KEEP SCORE
' --------------------
CALCULATESCORE:
SCORE = 0
FOR Z = 0 TO NUMBEROFITEMS
  IF ITEMLOCATIONS(Z) = TREASUREROOM THEN
    IF LEFT$(ITEM$(Z), 1) = "*" THEN
      SCORE = SCORE + 1
    END IF
  END IF
NEXT Z
RETURN

' ----------------------
'  GAME CARD ROUTINES
' ----------------------

CARDSUP:
VIEW PRINT 1 TO 25

DO
  QUICKSAVE = 0
  OPEN "CARDS.SAT" FOR INPUT AS #1
  TOTALCARDS = 0
  DO
    INPUT #1, TEMP$
    IF TEMP$ = "~~~" THEN TOTALCARDS = TOTALCARDS + 1
  LOOP WHILE NOT EOF(1)
  CLOSE #1

  TEMP = 0
  OPEN "CARDS.SAT" FOR INPUT AS #1
  DO
    INPUT #1, TEMP$
    IF TEMP$ = "~~~" THEN TEMP = TEMP + 1
  LOOP WHILE NOT EOF(1) AND TEMP < CN
  INPUT #1, CARDCOLOR
  LINE INPUT #1, CARDDESC$
  INPUT #1, CARDID
  CLOSE #1

  COLOR 15, 0
  CLS
  PRINT "FILE MENU:"
  PRINT ""
  COLOR CARDCOLOR, 0
  PRINT "۲"
  PRINT "۲"
  PRINT "۲"
  PRINT "";
  COLOR 14, 0
  PRINT "";
  COLOR CARDCOLOR, 0
  PRINT ""
  PRINT
  COLOR 9, 0
  PRINT "CARD:"; CN; "OF"; TOTALCARDS
  COLOR 14, 0
  PRINT "DESCRIPTION:";
  COLOR 15, 0
  PRINT CARDDESC$
  COLOR 2, 0
  PRINT "THIS CARD APPEARS TO BE FOR: Unknown";
  COLOR 7, 0
  LOCATE 10, 30
        IF CARDID = 0 THEN PRINT "-SAVING YOUR PROGRESS-"
        IF CARDID = 6425 THEN PRINT "ADVENTURELAND"
        IF CARDID = 6223 THEN PRINT "PIRATE ADVENTURE"
        IF CARDID = 6402 THEN PRINT "MISSION IMPOSSIBLE"
        IF CARDID = 532 THEN PRINT "VOODOO CASTLE"
        IF CARDID = 5873 THEN PRINT "THE COUNT"
        IF CARDID = 5623 THEN PRINT "STRANGE ODYSSEY"
        IF CARDID = 5804 THEN PRINT "MYSTERY FUN HOUSE"
        IF CARDID = 5519 THEN PRINT "PYRAMID OF DOOM"
        IF CARDID = 5397 THEN PRINT "GHOST TOWN"
        IF CARDID = 5013 THEN PRINT "SAVAGE ISLAND: PART ONE"
        IF CARDID = 5377 THEN PRINT "SAVAGE ISLAND: PART TWO"
        IF CARDID = 5107 THEN PRINT "GOLDEN VOYAGE"
        IF CARDID = 5112 THEN PRINT "SORCEROR OF CLAYMORGUE CASTLE"
        IF CARDID = 729 THEN PRINT "RETURN TO PIRATES ISLE"
        IF CARDID = 702 THEN PRINT "BUCKAROO BANZAI"
        LOCATE 11, 1

  GOSUB DRAWMENU

  DO
    K$ = INKEY$
    IF MID$(K$, 2, 1) = "H" AND OPT > 0 THEN
      OPT = OPT - 1
      GOSUB DRAWMENU
    END IF
    IF MID$(K$, 2, 1) = "P" AND OPT < 6 THEN
      OPT = OPT + 1
      GOSUB DRAWMENU
    END IF
    IF MID$(K$, 2, 1) = "K" AND OPT > 0 THEN
      OPT = OPT - 1
      GOSUB DRAWMENU
    END IF
    IF MID$(K$, 2, 1) = "M" AND OPT < 6 THEN
      OPT = OPT + 1
      GOSUB DRAWMENU
    END IF

    IF K$ = CHR$(13) THEN
      IF OPT = 0 THEN GOSUB SAVEGAME
      IF OPT = 1 THEN GOSUB LOADGAME
      IF OPT = 2 AND CN < TOTALCARDS THEN CN = CN + 1
      IF OPT = 3 AND CN > 1 THEN CN = CN - 1
      IF OPT = 4 THEN
        QUICKSAVE = 1
        GOSUB SAVEGAME
      END IF
      IF OPT = 5 THEN GOSUB GAMECOLORS
      IF OPT = 6 THEN K$ = CHR$(27)
    END IF
  LOOP WHILE K$ <> CHR$(13) AND K$ <> CHR$(27)
LOOP WHILE K$ <> CHR$(27)
COLOR FCBOT, BCBOT
CLS
RETURN

' ---------------------------------------------
'  DRAW THE MENU FOR THE FILE OPTIONS SCREEN
' ---------------------------------------------
DRAWMENU:
LOCATE 13
COLOR 15, 0
PRINT "ͻ"
IF OPT = 0 THEN COLOR 0, 15
PRINT "SAVE GAME TO CURRENT CARD                    "
COLOR 15, 0
IF OPT = 1 THEN COLOR 0, 15
PRINT "LOAD GAME FROM CURRENT CARD                  "
COLOR 15, 0
IF OPT = 2 THEN COLOR 0, 15
PRINT "NEXT GAME CARD                               "
COLOR 15, 0
IF OPT = 3 THEN COLOR 0, 15
PRINT "PREVOUS GAME CARD                            "
COLOR 15, 0
IF OPT = 4 THEN COLOR 0, 15
PRINT "QUICK-SAVE TO CURRENT CARD                   "
COLOR 15, 0
IF OPT = 5 THEN COLOR 0, 15
PRINT "GAME COLOR OPTIONS                           "
COLOR 15, 0
IF OPT = 6 THEN COLOR 0, 15
PRINT "RETURN TO GAME                               "
COLOR 15, 0
PRINT "ͼ"
PRINT
PRINT "Use the arrow keys to make a selection then press enter."
RETURN

' -------------
'  SAVE GAME
'--------------
SAVEGAME:

GAMESAVED = 0
COLOR 14, 0
CLS

IF QUICKSAVE = 1 THEN
  CARDID = 0
  DESC$ = "-QUICKSAVE-"
  IF LEN(DESCRIPTION$(CURRENTROOM)) < 55 THEN DESC$ = DESCRIPTION$(CURRENTROOM) + " (QUICKSAVE)"
  CC = 1
END IF

  IF CARDID > 0 THEN
    DO
      PRINT
      PRINT "Do you wish to overwrite the current card (Y/N):";
      CH$ = UCASE$(INPUT$(1))
    LOOP WHILE CH$ <> "N" AND CH$ <> "Y"
  END IF

  IF CH$ = "Y" OR CARDID = 0 THEN
    GAMESAVED = 1
    K$ = CHR$(27)
   
    IF QUICKSAVE = 0 THEN

      DO
        PRINT "PLEASE ENTER A SHORT DESCRIPTION FOR THIS FILE (1 LINE MAX)"
        LINE INPUT ">", DESC$
      LOOP WHILE LEN(DESC$) > 80

      DO
        PRINT "PLEASE CHOOSE A COLOR FOR THIS CARD:"
        FOR X = 1 TO 15
          COLOR X, 0
          PRINT STR$(X); "-";
        NEXT X
        PRINT
        INPUT "(1-15):", CC
      LOOP WHILE CC < 1 OR CC > 15
      COLOR 15, 0

    END IF

    PRINT
    PRINT "SAVING..."

    OPEN "CARDS.SAT" FOR INPUT AS #1
    OPEN "NEWCARDS.SAT" FOR OUTPUT AS #2
    CLOSE #2
    KILL "NEWCARDS.SAT"
    OPEN "NEWCARDS.SAT" FOR OUTPUT AS #2
   
    LINE INPUT #1, TEMP$
    PRINT #2, CN

    LCN = 0
    DO
      LINE INPUT #1, TEMP$
      IF TEMP$ = "~~~" THEN LCN = LCN + 1
      PRINT #2, TEMP$
    LOOP WHILE LCN < CN
 
    PRINT #2, CC
    PRINT #2, DESC$
    PRINT #2, ID

    FOR SGAME = 0 TO 100
      PRINT #2, BITFLAGS(SGAME)
      PRINT #2, COUNTERS(SGAME)
    NEXT SGAME

    FOR SGAME = 0 TO 200
      PRINT #2, ITEMLOCATIONS(SGAME)
    NEXT SGAME

    FOR SGAME = 0 TO 50
      PRINT #2, SWAPROOMS(SGAME)
    NEXT SGAME
 
    PRINT #2, CURRENTROOM
    PRINT #2, LAMP
    PRINT #2, FCTOP
    PRINT #2, BCTOP
    PRINT #2, FCBOT
    PRINT #2, BCBOT
    PRINT #2, LAMP
    PRINT #2, INVENTORYWEIGHT

    IF CN < TOTALCARDS THEN
      DO
        LINE INPUT #1, TEMP$
      LOOP WHILE TEMP$ <> "~~~"
      PRINT #2, TEMP$
      DO
        LINE INPUT #1, TEMP$
        PRINT #2, TEMP$
      LOOP WHILE NOT EOF(1)
    END IF
    CLOSE #1
    CLOSE #2
    KILL "CARDS.SAT"
    OPEN "NEWCARDS.SAT" FOR INPUT AS #1
    OPEN "CARDS.SAT" FOR OUTPUT AS #2
    DO
      LINE INPUT #1, TEMP$
      PRINT #2, TEMP$
    LOOP WHILE NOT EOF(1)
    CLOSE #1
    CLOSE #2
    KILL "NEWCARDS.SAT"
  END IF

RETURN

' -------------
'  LOAD GAME
' -------------
LOADGAME:
COLOR 14, 0
CLS

GAMELOADED = 0

IF CARDID <> ID THEN
  PRINT
  PRINT "This card does not contain a saved file for the current game."
  PRINT "Press any key"
  TEMP$ = INPUT$(1)
  RETURN
END IF

OPEN "CARDS.SAT" FOR INPUT AS #1

LCN = 0
DO
  LINE INPUT #1, TEMP$
  IF TEMP$ = "~~~" THEN LCN = LCN + 1
LOOP WHILE LCN < CN
INPUT #1, TEMP
LINE INPUT #1, TEMP$
INPUT #1, TEMP
FOR SGAME = 0 TO 100
  INPUT #1, BITFLAGS(SGAME)
  INPUT #1, COUNTERS(SGAME)
NEXT SGAME
FOR SGAME = 0 TO 200
  INPUT #1, ITEMLOCATIONS(SGAME)
NEXT SGAME
FOR SGAME = 0 TO 50
  INPUT #1, SWAPROOMS(SGAME)
NEXT SGAME
INPUT #1, CURRENTROOM
INPUT #1, LAMP
INPUT #1, FCTOP
INPUT #1, BCTOP
INPUT #1, FCBOT
INPUT #1, BCBOT
INPUT #1, LAMP
INPUT #1, INVENTORYWEIGHT
CLOSE #1
GAMELOADED = 1
K$ = CHR$(27)
RETURN

' ---------------------------------
'  PRETTY TEXT INTRO SCREEN...
'  LOOKS LIKE THE LONE PALM TREE
'  FROM SAVAGE ISLAND.
' ---------------------------------
INTROMENU:
COLOR 15, 3
PRINT "                                                                                "
PRINT "                                                 /\/\                           "
PRINT "                         /\/\                                                   "
PRINT "                                                                                "
PRINT "                                                                                "
PRINT "                                                                                "
PRINT "                                                                                "
DATA "       33 3 33                                                                  "
DATA "      33 3333333                                                                "
DATA "       33333 33 3                                                               "
DATA "66666636322366366666666666666666666666666666666666666666666666666666666666666666"
DATA "55555555225555555555555555555555555555555555555555555555555555555555555555555555"
DATA "44444442244444444444444444444444444444444444444444444444444444444444444444444444"
DATA "22"
DATA "22"
DATA "222"
DATA ""
DATA ""
DATA "111"
DATA "1111111111"
DATA "11111111111"
DATA "11111111111111"

FOR X = 8 TO 22
  READ DS$
  FOR Y = 1 TO 80
  LOCATE X, Y
    IF MID$(DS$, Y, 1) = " " THEN
      COLOR 15, 3
      PRINT " ";
    END IF
    IF MID$(DS$, Y, 1) = "6" THEN
      COLOR 0, 1
      PRINT "";
    END IF
    IF MID$(DS$, Y, 1) = "5" THEN
      COLOR 0, 1
      PRINT "";
    END IF
    IF MID$(DS$, Y, 1) = "4" THEN
      COLOR 0, 1
      PRINT "";
    END IF
    IF MID$(DS$, Y, 1) = "3" THEN
      COLOR 2, 0
      PRINT "";
    END IF
    IF MID$(DS$, Y, 1) = "2" THEN
      COLOR 6, 0
      PRINT "";
    END IF
    IF MID$(DS$, Y, 1) = "1" THEN
      COLOR 14, 10
      PRINT "";
    END IF
    IF MID$(DS$, Y, 1) = "" OR MID$(DS$, Y, 1) = "" THEN
      COLOR 14, 0
      PRINT MID$(DS$, Y, 1);
    END IF
  NEXT Y
NEXT X
COLOR 15, 0
PRINT "WELCOME THE THE QBASIC SCOTT ADAMS ADVENTURE GAME INTERPRETER.";
COLOR 10, 0
PRINT "VERSION 1.0, FREEWARE 1999 BY Chad Elliott... PRESS ANY KEY TO BEGIN";
LOCATE 1
K$ = INPUT$(1)
CLS
RETURN

' ----------------------
'  COLOR OPTIONS MENU
' ----------------------
GAMECOLORS:
OPTC = 0
COLOR 15, 2
CLS
DO
LOCATE 1
  COLOR FCTOP, BCTOP
  PRINT "ͻ"
  PRINT "Description window.             "
  PRINT "                                "
  PRINT "                                "
  PRINT "͹"
  COLOR FCBOT, BCBOT
  PRINT "Parser window                   "
  PRINT "                                "
  PRINT "                                "
  PRINT "                                "
  PRINT ">                               "
  PRINT "ͼ"

  LOCATE 13
  COLOR 15, 1
  PRINT "ͻ"
  IF OPTC = 0 THEN COLOR 0, 15
  PRINT "CHANGE TEXT COLOR OF TOP WINDOW              "
  COLOR 15, 1
  IF OPTC = 1 THEN COLOR 0, 15
  PRINT "CHANGE BACKGROUND COLOR OF TOP WINDOW        "
  COLOR 15, 1
  IF OPTC = 2 THEN COLOR 0, 15
  PRINT "CHANGE TEXT COLOR OF BOTTOM WINDOW           "
  COLOR 15, 1
  IF OPTC = 3 THEN COLOR 0, 15
  PRINT "CHANGE BACKGROUND COLOR OF BOTTOM WINDOW     "
  COLOR 15, 1
  IF OPTC = 4 THEN COLOR 0, 15
  PRINT "RESTORE DEFAULT COLORS                       "
  COLOR 15, 1
  IF OPTC = 5 THEN COLOR 0, 15
  PRINT "RETURN TO FILE MENU                          "
  COLOR 15, 1
  PRINT "ͼ"
  PRINT
  PRINT "Use the arrow keys to make a selection then press enter."

  DO
    K$ = INKEY$
  LOOP WHILE K$ = ""

  IF MID$(K$, 2, 1) = "H" AND OPTC > 0 THEN OPTC = OPTC - 1
  IF MID$(K$, 2, 1) = "P" AND OPTC < 5 THEN OPTC = OPTC + 1
  IF MID$(K$, 2, 1) = "K" AND OPTC > 0 THEN OPTC = OPTC - 1
  IF MID$(K$, 2, 1) = "M" AND OPTC < 5 THEN OPTC = OPTC + 1

    IF K$ = CHR$(13) THEN
      IF OPTC = 0 THEN FCTOP = FCTOP + 1
      IF OPTC = 1 THEN BCTOP = BCTOP + 1
      IF OPTC = 2 THEN FCBOT = FCBOT + 1
      IF OPTC = 3 THEN BCBOT = BCBOT + 1
      IF OPTC = 4 THEN
        FCTOP = 15
        BCTOP = 2
        FCBOT = 15
        BCBOT = 2
      END IF
      IF OPTC = 5 THEN
          K$ = CHR$(27)
      END IF
    END IF
    IF FCTOP > 15 THEN FCTOP = 0
    IF BCTOP > 15 THEN BCTOP = 0
    IF FCBOT > 15 THEN FCBOT = 0
    IF BCBOT > 15 THEN BCBOT = 0
LOOP WHILE K$ <> CHR$(27)
K$ = CHR$(13)
RETURN

